FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Controllers/TagsController.cs
using FA.JustBlog.Common;
using FA.JustBlog.Core.Infrastructures;
using FA.JustBlog.Core.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace FA.JustBlog.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Blog_Owner + "," + SD.Role_Contributor)]
    public class TagsController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public TagsController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {
            //ViewBag.Abc=..
            //ViewData["Abc"]==
            return View();
        }

        //GET
        public IActionResult Create()
        {
            return View();
        }

        //Tag
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Tag request)
        {

            if (ModelState.IsValid)
            {
                request.UrlSlug = SeoUrlHepler.FrientlyUrl(request.Name);
                this._unitOfWork.TagRepository.Add(request);
                _unitOfWork.SaveChange();
                TempData["success"] = "Tag created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Tag created error";
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var TagFromDbFirst = _unitOfWork.TagRepository.GetById(id.Value);
            if (TagFromDbFirst == null)
            {
                return NotFound();
            }

            return View(TagFromDbFirst);
        }

        //Tag
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Tag obj)
        {

            if (ModelState.IsValid)
            {
                obj.UrlSlug = SeoUrlHepler.FrientlyUrl(obj.Name);
                _unitOfWork.TagRepository.Update(obj);
                _unitOfWork.SaveChange();
                TempData["success"] = "Tag updated successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Tag created error";
            return View(obj);
        }



        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.TagRepository.GetAll();
            return Json(new { data = productList });
        }

        
        //Tag
        [HttpDelete]
        [Authorize(Roles = SD.Role_Blog_Owner)]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.TagRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.TagRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
        #endregion

    }
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Tags/Create.cshtml
@model Tag
@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
	
}
<form method="post"  asp-action="Create" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
	<div class="border p-3 mt-4" >
		<div class="row pb-6">
			<h2 class="text-primary">Create Tag</h2>
			<hr />
		</div>
		@*<div asp-validation-summary="All"></div>*@
		<div class="mb-3">
			<label asp-for="Name"></label>
			<input asp-for="Name" class="form-control" onchange="myFunction()" />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="Count"></label>
			<input asp-for="Count" rows="3" class="form-control"></input>
			<span asp-validation-for="Count" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="Description"></label>
			<textarea asp-for="Description" rows="3" class="form-control"></textarea>
			<span asp-validation-for="Description" class="text-danger"></span>
		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">Create</button>
		<a asp-controller="Tags" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to List
		</a>
	</div>
</form>

@section Scripts{
	@{
		<partial name="_ValidationScriptsPartial" />
	}
	<script>
    tinymce.init({
      selector: 'textarea',
      plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
      toolbar_mode: 'floating',
   });
  
	function ValidateInput(){
		if(document.getElementById("uploadBox").value==""){
			Swal.fire({
			  icon: 'error',
			  title: 'Oops...',
			  text: 'Please upload an Image!',
			});
			return false;
		}
		return true;
	}
</script>
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Tags/Edit.cshtml
@model Tag
@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
}

<form method="post" asp-action="Edit" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
    <div class="border p-3 mt-4">
        <div class="row pb-6">
            <h2 class="text-primary">Edit Tag</h2>
            <hr />
        </div>
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
        <input type="hidden" asp-for="Id" />
        <div class="mb-3">
            <label asp-for="Name" class="control-label"></label>
            <input asp-for="Name" class="form-control" />
            <span asp-validation-for="Name" class="text-danger"></span>
        </div>
      
        <div class="mb-3">
            <label asp-for="Description" class="control-label"></label>
            <textarea asp-for="Description" rows="3" class="form-control"></textarea>
            <span asp-validation-for="Description" class="text-danger"></span>
        </div>
        <div class="mb-3">
            <label asp-for="UrlSlug" class="control-label"></label>
            <input asp-for="UrlSlug" class="form-control" disabled />
            <span asp-validation-for="UrlSlug" class="text-danger"></span>
        </div>
        <div class="mb-3">
            <label asp-for="Count" class="control-label"></label>
            <input asp-for="Count" class="form-control" />
            <span asp-validation-for="Count" class="text-danger"></span>
        </div>
        <div class="mb-3">
            <input type="submit" value="Save" class="btn btn-primary" />
        </div>
    </div>
</form>


<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts{
	@{
    <partial name="_ValidationScriptsPartial" />
	}
<script>
     tinymce.init({
       selector: 'textarea',
       plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
       toolbar_mode: 'floating',
    });

     function ValidateInput(){
         if(document.getElementById("uploadBox").value==""){
             Swal.fire({
               icon: 'error',
               title: 'Oops...',
               text: 'Please upload an Image!',
             });
             return false;
         }
         return true;
     }
</script>
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Tags/Index.cshtml
@{
    ViewData["Title"] = "Index";
}
    <div class="container p-3">
        <div class="row pt-4">
            <div class="col-6">
                <h2 class="text-primary">Tag List</h2>
            </div>
            <div class="col-6 text-end">
                <a asp-controller="Tags" asp-action="Create" class="btn btn-primary">
                    <i class="bi bi-plus-circle"></i> &nbsp; Create New Tag
                </a>
            </div>
        </div>
        <br /><br />

        <table id="tblData" class="table table-bPostsed table-striped" style="width:100%">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>UrlSlug</th>
                    <th>Count</th>
                    <th>Description</th>
                    <th></th>
                </tr>
            </thead>
        </table>
    </div>

@section scripts{
    <script src="~/js/tag.js"></script>
}